Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents picCanvas As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.picCanvas = New System.Windows.Forms.PictureBox
        Me.SuspendLayout()
        '
        'picCanvas
        '
        Me.picCanvas.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.picCanvas.Dock = System.Windows.Forms.DockStyle.Fill
        Me.picCanvas.Location = New System.Drawing.Point(0, 0)
        Me.picCanvas.Name = "picCanvas"
        Me.picCanvas.Size = New System.Drawing.Size(292, 273)
        Me.picCanvas.TabIndex = 1
        Me.picCanvas.TabStop = False
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Controls.Add(Me.picCanvas)
        Me.Name = "Form1"
        Me.Text = "Form1"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Const GAP As Integer = 2

    ' The endpoints are points 0 and 3. 
    ' The control points are points 1 and 2.
    ' A point with negative coordinates is not yet defined.
    Private m_Pts() As PointF

    ' The index of the next point to define.
    Private m_NumPoints As Integer = 0

    Private Tension As Single = 0.5

    ' Prepare to draw the Bezier curve.
    Private Sub DrawBezier(ByVal gr As Graphics, ByVal pt0 As PointF, ByVal pt1 As PointF, ByVal pt2 As PointF, ByVal pt3 As PointF)
        ' Draw the control lines.
        Dim dashed_pen As New Pen(Color.Black)
        dashed_pen.DashStyle = Drawing2D.DashStyle.Custom
        dashed_pen.DashPattern = New Single() {4, 4}
        gr.DrawLine(dashed_pen, pt0.X, pt0.Y, pt1.X, pt1.Y)
        gr.DrawLine(dashed_pen, pt2.X, pt2.Y, pt3.X, pt3.Y)
        dashed_pen.Dispose()

        ' Draw the control points.
        gr.FillRectangle(Brushes.White, pt0.X - 3, pt0.Y - 3, 6, 6)
        gr.DrawRectangle(Pens.Black, pt0.X - 3, pt0.Y - 3, 6, 6)
        gr.FillRectangle(Brushes.LightGray, pt1.X - 3, pt1.Y - 3, 6, 6)
        gr.DrawRectangle(Pens.Gray, pt1.X - 3, pt1.Y - 3, 6, 6)
        gr.FillRectangle(Brushes.LightGray, pt2.X - 3, pt2.Y - 3, 6, 6)
        gr.DrawRectangle(Pens.Gray, pt2.X - 3, pt2.Y - 3, 6, 6)
        gr.FillRectangle(Brushes.White, pt3.X - 3, pt3.Y - 3, 6, 6)
        gr.DrawRectangle(Pens.Black, pt3.X - 3, pt3.Y - 3, 6, 6)

        ' Draw the curve.
        DrawCurve(gr, 0, 1, 0.01, pt0, pt1, pt2, pt3)
    End Sub

    ' Select a point.
    Private Sub picCanvas_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picCanvas.MouseDown
        If e.Button = MouseButtons.Right Then
            ' Start over.
            m_NumPoints = 0
        Else
            ' Get another point.
            ReDim Preserve m_Pts(m_NumPoints)
            m_Pts(m_NumPoints).X = e.X
            m_Pts(m_NumPoints).Y = e.Y
            m_NumPoints += 1
        End If

        ' Redraw.
        picCanvas.Invalidate()
    End Sub

    ' The parametric function X(t).
    Private Function X(ByVal t As Single, ByVal x0 As Single, ByVal x1 As Single, ByVal x2 As Single, ByVal x3 As Single) As Single
        X = CSng( _
            x0 * (1 - t) ^ 3 + _
            x1 * 3 * t * (1 - t) ^ 2 + _
            x2 * 3 * t ^ 2 * (1 - t) + _
            x3 * t ^ 3 _
            )
    End Function

    ' The parametric function Y(t).
    Private Function Y(ByVal t As Single, ByVal y0 As Single, ByVal y1 As Single, ByVal y2 As Single, ByVal y3 As Single) As Single
        Y = CSng( _
            y0 * (1 - t) ^ 3 + _
            y1 * 3 * t * (1 - t) ^ 2 + _
            y2 * 3 * t ^ 2 * (1 - t) + _
            y3 * t ^ 3 _
            )
    End Function

    ' Compute the Bezier curve parameters.
    Private Sub GetBezierValues(ByVal pt0 As PointF, ByVal pt1 As PointF, ByVal pt2 As PointF, ByVal pt3 As PointF, ByRef Ax As Single, ByRef Bx As Single, ByRef Cx As Single, ByRef Dx As Single, ByRef Ay As Single, ByRef By As Single, ByRef Cy As Single, ByRef Dy As Single)
        Ax = pt3.X - pt0.X - 3 * pt2.X + 3 * pt1.X
        Bx = 3 * pt0.X - 6 * pt1.X + 3 * pt2.X
        Cx = -3 * pt0.X + 3 * pt1.X
        Dx = pt0.X

        Ay = pt3.Y - pt0.Y - 3 * pt2.Y + 3 * pt1.Y
        By = 3 * pt0.Y - 6 * pt1.Y + 3 * pt2.Y
        Cy = -3 * pt0.Y + 3 * pt1.Y
        Dy = pt0.Y
    End Sub

    ' Draw the curve on the indicated picture box.
    Private Sub DrawCurve(ByVal gr As Graphics, ByVal start_t As Single, ByVal stop_t As Single, ByVal dt As Single, ByVal pt0 As PointF, ByVal pt1 As PointF, ByVal pt2 As PointF, ByVal pt3 As PointF)
        Dim t, x0, y0, x1, y1 As Single

        t = start_t
        x1 = X(t, pt0.X, pt1.X, pt2.X, pt3.X)
        y1 = Y(t, pt0.Y, pt1.Y, pt2.Y, pt3.Y)
        t += dt
        Do While t < stop_t
            x0 = x1
            y0 = y1
            x1 = X(t, pt0.X, pt1.X, pt2.X, pt3.X)
            y1 = Y(t, pt0.Y, pt1.Y, pt2.Y, pt3.Y)
            gr.DrawLine(Pens.Black, x0, y0, x1, y1)
            t += dt
        Loop
    End Sub

    Private Sub picCanvas_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles picCanvas.Paint
        e.Graphics.Clear(Me.BackColor)
        If m_NumPoints < 1 Then Exit Sub

        ' Draw a spline the easy way.
        If m_NumPoints > 1 Then
            Dim thick_pen As New Pen(Color.White, 5)
            e.Graphics.DrawCurve(thick_pen, m_Pts)
            thick_pen.Dispose()
        End If

        Dim A As Single = CSng(Tension / 0.5 * 0.175)
        Dim pt, pt_before, pt_after, pt_after2, Di, DiPlus1 As PointF
        Dim p1, p2, p3, p4 As PointF
        For i As Integer = 0 To m_Pts.GetUpperBound(0) - 1
            pt_before = m_Pts(Math.Max(i - 1, 0))
            pt = m_Pts(i)
            pt_after = m_Pts(i + 1)
            pt_after2 = m_Pts(Math.Min(i + 2, m_Pts.GetUpperBound(0)))

            p1 = m_Pts(i)
            p4 = m_Pts(i + 1)

            Di.X = pt_after.X - pt_before.X
            Di.Y = pt_after.Y - pt_before.Y
            p2.X = pt.X + A * Di.X
            p2.Y = pt.Y + A * Di.Y

            DiPlus1.X = pt_after2.X - m_Pts(i).X
            DiPlus1.Y = pt_after2.Y - m_Pts(i).Y
            p3.X = pt_after.X - A * DiPlus1.X
            p3.Y = pt_after.Y - A * DiPlus1.Y

            DrawBezier(e.Graphics, p1, p2, p3, p4)
        Next i
    End Sub
End Class
